︠8aac6af7-db69-4593-9bb5-7ce6d39604cei︠
%html
<h2>NFL Quarterback Passer Rating</h2>
<p>Formula from&nbsp;<a href="http://www.nfl.com/help/quarterbackratingformula">http://www.nfl.com/help/quarterbackratingformula</a></p>
<p>Idea from&nbsp;<a href="http://demonstrations.wolfram.com/NFLQuarterbackPasserRating/">http://demonstrations.wolfram.com/NFLQuarterbackPasserRating/</a></p>

︡f292c54e-bc8b-4ed9-a0c0-cae3e61aa412︡{"html": "<h2>NFL Quarterback Passer Rating</h2>\n<p>Formula from&nbsp;<a href=\"http://www.nfl.com/help/quarterbackratingformula\">http://www.nfl.com/help/quarterbackratingformula</a></p>\n<p>Idea from&nbsp;<a href=\"http://demonstrations.wolfram.com/NFLQuarterbackPasserRating/\">http://demonstrations.wolfram.com/NFLQuarterbackPasserRating/</a></p>"}︡
︠8edd7abf-d11c-404f-9c75-f37363fcefb7︠
%cython
cdef int passpercent, comppass, passyrds, tdpass, intercept

cdef float bound(float x):
    return max(0, min(2.375, x))

cpdef float qb(float passatt, float comppass, float passyrds, float tdpass, float intercept):
    """
    quarterback rating formula
    """
    ret = bound((comppass/passatt * 100 - 30) * 0.05)
    ret += bound((passyrds/passatt - 3) * 0.25)
    ret += bound((tdpass/passatt) * 100 * 0.2)
    ret += bound((2.375 - (intercept/passatt) * 100 * 0.25))
    return ret * 100 / 6
    
cpdef float qb_avg(float passatt, float avgpassatt, float comppass, float avgpassyards, float tdpass, float intercept):
    """
    quarterback rating formula, average value arguments
    """
    ret = bound((avgpassatt - 30) * 0.05)
    ret += bound((avgpassyards - 3) * 0.25)
    ret += bound((tdpass/passatt) * 100 * 0.2)
    ret += bound((2.375 - (intercept/passatt) * 100 * 0.25))
    return ret * 100 / 6
︡cb2dbe0d-958b-4cde-970d-aaa3aea5dff4︡︡
︠7050c18e-c578-4042-9006-3c2b1d21b5aa︠
qb(passatt=44, comppass=33, passyrds=11, tdpass=2, intercept=2)
︡844ab4de-8842-42ca-807f-bb88ae4fe833︡{"stdout": "73.295455932617188"}︡
︠5719a58c-37c7-4d75-8a4c-781ccd66a218︠
var('y p')
p1 = plot3d(lambda y,p: qb_avg(44,p,5, y, 2, 2),(y, 1,50), (p, 1,100))
p2 = point3d((11, 50, qb(44, 33, 11, 2, 2)), size=30, rgbcolor='orange')
show(p1+p2)
︡6a7a3552-166e-44f4-b107-088d084a5a33︡︡
︠cb96a752-39e8-42f0-af13-9f6bc676a7c2︠
@interact
def calc_quarterback_rating(
    passatt = (1,100,1),\
    comppass = (0,20,1),\
    passyrds = (1,2000,1),\
    tdpass = (0,10,1),\
    intercept = (0,20,1)):
        
    passydadj = n(max(20, min(100, passyrds/passatt))) 
    passpercent = 100*comppass/passatt
    avgpassyards = passyrds/passatt
    qb_rating = qb(passatt, comppass, passyrds, tdpass, intercept)
    
    print 'Pass Percentage:    %3.2f%%' % (passpercent)
    print 'Avg. Yards/Pass:    %3.2f' %(avgpassyards)
    print 'Quarterback-Rating: %3.2f' % (qb_rating)
    
    p1 = plot3d(lambda p,y: qb_avg(passatt, p, comppass, y, tdpass, intercept), (p, 1, 100),(y, 1,passydadj))
    p2 = point3d((passpercent, avgpassyards, qb_rating), size=30, rgbcolor='orange')
    show(p1+p2)
︡c28b1f81-d278-4053-a61a-638483fab7b5︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-10\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table><tr><td align=right><font color=\"black\">passatt&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-passatt-10\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-passatt-10-lbl\"></font></td></tr></table><script>(function(){ var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\",\"21\",\"22\",\"23\",\"24\",\"25\",\"26\",\"27\",\"28\",\"29\",\"30\",\"31\",\"32\",\"33\",\"34\",\"35\",\"36\",\"37\",\"38\",\"39\",\"40\",\"41\",\"42\",\"43\",\"44\",\"45\",\"46\",\"47\",\"48\",\"49\",\"50\",\"51\",\"52\",\"53\",\"54\",\"55\",\"56\",\"57\",\"58\",\"59\",\"60\",\"61\",\"62\",\"63\",\"64\",\"65\",\"66\",\"67\",\"68\",\"69\",\"70\",\"71\",\"72\",\"73\",\"74\",\"75\",\"76\",\"77\",\"78\",\"79\",\"80\",\"81\",\"82\",\"83\",\"84\",\"85\",\"86\",\"87\",\"88\",\"89\",\"90\",\"91\",\"92\",\"93\",\"94\",\"95\",\"96\",\"97\",\"98\",\"99\",\"100\"]; setTimeout(function() {\n    $('#slider-passatt-10').slider({\n        step: 1, min: 0, max: 99, value: 0,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-passatt-10-lbl').text(values[position]); interact(10, '_interact_.update(\\'10\\', \\'passatt\\', 1, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'10\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-passatt-10-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-passatt-10-lbl').text(values[$('#slider-passatt-10').slider('value')]);\n    }, 1); })();</script></td></tr>\n<tr><td align=right><font color=\"black\">comppass&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-comppass-10\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-comppass-10-lbl\"></font></td></tr></table><script>(function(){ var values = [\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\"]; setTimeout(function() {\n    $('#slider-comppass-10').slider({\n        step: 1, min: 0, max: 20, value: 0,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-comppass-10-lbl').text(values[position]); interact(10, '_interact_.update(\\'10\\', \\'comppass\\', 2, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'10\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-comppass-10-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-comppass-10-lbl').text(values[$('#slider-comppass-10').slider('value')]);\n    }, 1); })();</script></td></tr>\n<tr><td align=right><font color=\"black\">passyrds&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-passyrds-10\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-passyrds-10-lbl\"></font></td></tr></table><script>(function(){ var values = [\"1\",\"5\",\"9\",\"13\",\"17\",\"21\",\"25\",\"29\",\"33\",\"37\",\"41\",\"45\",\"49\",\"53\",\"57\",\"61\",\"65\",\"69\",\"73\",\"77\",\"81\",\"85\",\"89\",\"93\",\"97\",\"101\",\"105\",\"109\",\"113\",\"117\",\"121\",\"125\",\"129\",\"133\",\"137\",\"141\",\"145\",\"149\",\"153\",\"157\",\"161\",\"165\",\"169\",\"173\",\"177\",\"181\",\"185\",\"189\",\"193\",\"197\",\"201\",\"205\",\"209\",\"213\",\"217\",\"221\",\"225\",\"229\",\"233\",\"237\",\"241\",\"245\",\"249\",\"253\",\"257\",\"261\",\"265\",\"269\",\"273\",\"277\",\"281\",\"285\",\"289\",\"293\",\"297\",\"301\",\"305\",\"309\",\"313\",\"317\",\"321\",\"325\",\"329\",\"333\",\"337\",\"341\",\"345\",\"349\",\"353\",\"357\",\"361\",\"365\",\"369\",\"373\",\"377\",\"381\",\"385\",\"389\",\"393\",\"397\",\"401\",\"405\",\"409\",\"413\",\"417\",\"421\",\"425\",\"429\",\"433\",\"437\",\"441\",\"445\",\"449\",\"453\",\"457\",\"461\",\"465\",\"469\",\"473\",\"477\",\"481\",\"485\",\"489\",\"493\",\"497\",\"501\",\"505\",\"509\",\"513\",\"517\",\"521\",\"525\",\"529\",\"533\",\"537\",\"541\",\"545\",\"549\",\"553\",\"557\",\"561\",\"565\",\"569\",\"573\",\"577\",\"581\",\"585\",\"589\",\"593\",\"597\",\"601\",\"605\",\"609\",\"613\",\"617\",\"621\",\"625\",\"629\",\"633\",\"637\",\"641\",\"645\",\"649\",\"653\",\"657\",\"661\",\"665\",\"670\",\"674\",\"678\",\"682\",\"686\",\"690\",\"694\",\"698\",\"702\",\"706\",\"710\",\"714\",\"718\",\"722\",\"726\",\"730\",\"734\",\"738\",\"742\",\"746\",\"750\",\"754\",\"758\",\"762\",\"766\",\"770\",\"774\",\"778\",\"782\",\"786\",\"790\",\"794\",\"798\",\"802\",\"806\",\"810\",\"814\",\"818\",\"822\",\"826\",\"830\",\"834\",\"838\",\"842\",\"846\",\"850\",\"854\",\"858\",\"862\",\"866\",\"870\",\"874\",\"878\",\"882\",\"886\",\"890\",\"894\",\"898\",\"902\",\"906\",\"910\",\"914\",\"918\",\"922\",\"926\",\"930\",\"934\",\"938\",\"942\",\"946\",\"950\",\"954\",\"958\",\"962\",\"966\",\"970\",\"974\",\"978\",\"982\",\"986\",\"990\",\"994\",\"998\",\"1002\",\"1006\",\"1010\",\"1014\",\"1018\",\"1022\",\"1026\",\"1030\",\"1034\",\"1038\",\"1042\",\"1046\",\"1050\",\"1054\",\"1058\",\"1062\",\"1066\",\"1070\",\"1074\",\"1078\",\"1082\",\"1086\",\"1090\",\"1094\",\"1098\",\"1102\",\"1106\",\"1110\",\"1114\",\"1118\",\"1122\",\"1126\",\"1130\",\"1134\",\"1138\",\"1142\",\"1146\",\"1150\",\"1154\",\"1158\",\"1162\",\"1166\",\"1170\",\"1174\",\"1178\",\"1182\",\"1186\",\"1190\",\"1194\",\"1198\",\"1202\",\"1206\",\"1210\",\"1214\",\"1218\",\"1222\",\"1226\",\"1230\",\"1234\",\"1238\",\"1242\",\"1246\",\"1250\",\"1254\",\"1258\",\"1262\",\"1266\",\"1270\",\"1274\",\"1278\",\"1282\",\"1286\",\"1290\",\"1294\",\"1298\",\"1302\",\"1306\",\"1310\",\"1314\",\"1318\",\"1322\",\"1326\",\"1330\",\"1335\",\"1339\",\"1343\",\"1347\",\"1351\",\"1355\",\"1359\",\"1363\",\"1367\",\"1371\",\"1375\",\"1379\",\"1383\",\"1387\",\"1391\",\"1395\",\"1399\",\"1403\",\"1407\",\"1411\",\"1415\",\"1419\",\"1423\",\"1427\",\"1431\",\"1435\",\"1439\",\"1443\",\"1447\",\"1451\",\"1455\",\"1459\",\"1463\",\"1467\",\"1471\",\"1475\",\"1479\",\"1483\",\"1487\",\"1491\",\"1495\",\"1499\",\"1503\",\"1507\",\"1511\",\"1515\",\"1519\",\"1523\",\"1527\",\"1531\",\"1535\",\"1539\",\"1543\",\"1547\",\"1551\",\"1555\",\"1559\",\"1563\",\"1567\",\"1571\",\"1575\",\"1579\",\"1583\",\"1587\",\"1591\",\"1595\",\"1599\",\"1603\",\"1607\",\"1611\",\"1615\",\"1619\",\"1623\",\"1627\",\"1631\",\"1635\",\"1639\",\"1643\",\"1647\",\"1651\",\"1655\",\"1659\",\"1663\",\"1667\",\"1671\",\"1675\",\"1679\",\"1683\",\"1687\",\"1691\",\"1695\",\"1699\",\"1703\",\"1707\",\"1711\",\"1715\",\"1719\",\"1723\",\"1727\",\"1731\",\"1735\",\"1739\",\"1743\",\"1747\",\"1751\",\"1755\",\"1759\",\"1763\",\"1767\",\"1771\",\"1775\",\"1779\",\"1783\",\"1787\",\"1791\",\"1795\",\"1799\",\"1803\",\"1807\",\"1811\",\"1815\",\"1819\",\"1823\",\"1827\",\"1831\",\"1835\",\"1839\",\"1843\",\"1847\",\"1851\",\"1855\",\"1859\",\"1863\",\"1867\",\"1871\",\"1875\",\"1879\",\"1883\",\"1887\",\"1891\",\"1895\",\"1899\",\"1903\",\"1907\",\"1911\",\"1915\",\"1919\",\"1923\",\"1927\",\"1931\",\"1935\",\"1939\",\"1943\",\"1947\",\"1951\",\"1955\",\"1959\",\"1963\",\"1967\",\"1971\",\"1975\",\"1979\",\"1983\",\"1987\",\"1991\",\"1995\",\"2000\"]; setTimeout(function() {\n    $('#slider-passyrds-10').slider({\n        step: 1, min: 0, max: 499, value: 0,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-passyrds-10-lbl').text(values[position]); interact(10, '_interact_.update(\\'10\\', \\'passyrds\\', 3, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'10\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-passyrds-10-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-passyrds-10-lbl').text(values[$('#slider-passyrds-10').slider('value')]);\n    }, 1); })();</script></td></tr>\n<tr><td align=right><font color=\"black\">tdpass&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-tdpass-10\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-tdpass-10-lbl\"></font></td></tr></table><script>(function(){ var values = [\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\"]; setTimeout(function() {\n    $('#slider-tdpass-10').slider({\n        step: 1, min: 0, max: 10, value: 0,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-tdpass-10-lbl').text(values[position]); interact(10, '_interact_.update(\\'10\\', \\'tdpass\\', 4, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'10\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-tdpass-10-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-tdpass-10-lbl').text(values[$('#slider-tdpass-10').slider('value')]);\n    }, 1); })();</script></td></tr>\n<tr><td align=right><font color=\"black\">intercept&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-intercept-10\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-intercept-10-lbl\"></font></td></tr></table><script>(function(){ var values = [\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\"]; setTimeout(function() {\n    $('#slider-intercept-10').slider({\n        step: 1, min: 0, max: 20, value: 0,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-intercept-10-lbl').text(values[position]); interact(10, '_interact_.update(\\'10\\', \\'intercept\\', 5, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'10\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-intercept-10-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-intercept-10-lbl').text(values[$('#slider-intercept-10').slider('value')]);\n    }, 1); })();</script></td></tr>\n</table><div id=\"cell-interact-10\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100% height=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td>\n                 </tr></table></div>\n                 "}︡
